/**
 * Dojo 13-06-2012
 * Simples ocr usando TDD
 */

#include <stdio.h>
#include <string.h>

#define LINE_SIZ 28

/*
 * MinUnit, usada para unit test
 */
#define MU_ASSERT(MSG, TEST) do {if (!(TEST)) return MSG;} while(0)

#define MU_RUN_TEST(TEST) do {char* MSG = TEST(); \
tests_run++; \
if (MSG) return MSG; } while(0)

int tests_run = 0;
/* fim MinUnit */


/* Programa real */
/* Vetor de testes */
char* display_testes[] = {
" _  _  _  _  _  _  _  _  _ \n"
"| || || || || || || || || |\n"
"|_||_||_||_||_||_||_||_||_|\n",
" _  _  _  _  _  _  _  _    \n"
"| || || || || || || || |  |\n"
"|_||_||_||_||_||_||_||_|  |\n",
" _  _  _  _  _  _  _  _    \n"
"| || || || || || || || ||_|\n"
"|_||_||_||_||_||_||_||_|  |\n",
" _  _  _  _  _  _  _  _  _ \n"
"| || || || || || || || ||_|\n"
"|_||_||_||_||_||_||_||_| _|\n",
" _  _  _  _  _  _  _  _  _ \n"
"| || || || || || || || ||_|\n"
"|_||_||_||_||_||_||_||_||_|\n",
" _  _  _  _  _  _  _  _  _ \n"
"| || || || || || || |  || |\n"
"|_||_||_||_||_||_||_|  ||_|\n",
" _  _  _  _  _  _  _     _ \n"
"| || || || || || || |  | _|\n"
"|_||_||_||_||_||_||_|  | _|\n",
" _  _  _  _  _  _  _  _  _ \n"
"| || || || || || || |  |  |\n"
"|_||_||_||_||_||_||_|  |  |\n",
"    _  _     _  _  _  _  _ \n"
"  | _| _||_||_ |_   ||_||_|\n"
"  ||_  _|  | _||_|  ||_| _|\n",
" _  _  _  _  _     _  _    \n"
"|_||_|  ||_ |_ |_| _| _|  |\n"
" _||_|  ||_| _|  | _||_   |\n"};

/* Funções auxiliares */

/* Coloca 1 em todas as posições da matriz 10x9*/
void set_labels(char M[10][9]) {
	int idx, jdx;

	for (idx=0; idx<10; ++idx)
		for (jdx=0; jdx<9; ++jdx)
			M[idx][jdx] = 1;
}

/* Funções testadas */

void checa_primeira_linha(const char* s, char labels[10][9]) {
	int i;

	for (i=0; 3*i < LINE_SIZ - 1; ++i) {
		if (strncmp(s + 3*i, "   ", 3) == 0) { 
		/* Pode ser 4 ou 1, desmarca os demais */
			labels[9][i] = labels[8][i] = labels[7][i] = labels[6][i] =
			labels[5][i] = labels[3][i] = labels[2][i] = labels[0][i] = 0;
		} else {
		/* Não pode ser 4 ou 1 */
			labels[4][i] = labels[1][i] = 0;
		}
	}
}

void checa_segunda_linha(const char* s, char labels[10][9]) {
	/* usa strncmp() para verificar padrão do meio da string
	 * possíveis: "| |", "|_|", " _|", "|_ ", "  |"	
	 */
	int i;

	for (i=0; 3*i < LINE_SIZ - 1; ++i) {
		if (strncmp(s + LINE_SIZ + 3*i, "| |", 3) == 0) {
		/* Pode ser 0 */
			labels[9][i] = labels[8][i] = labels[7][i] = labels[6][i] =
			labels[5][i] = labels[4][i] = labels[3][i] = labels[2][i] =
			labels[1][i] = 0;

		} else if (strncmp(s + LINE_SIZ + 3*i, "|_|", 3) == 0) {
		/* Pode ser 9, 8, 4 */
			labels[7][i] = labels[6][i] = labels[5][i] = labels[3][i] =
			labels[2][i] = labels[1][i] = labels[0][i] = 0;

		} else if (strncmp(s + LINE_SIZ + 3*i, " _|", 3) == 0) {
		/* Pode ser 3, 2 */
			labels[9][i] = labels[8][i] = labels[7][i] = labels[6][i] =
			labels[5][i] = labels[4][i] = labels[1][i] = labels[0][i] = 0;

		} else if (strncmp(s + LINE_SIZ + 3*i, "|_ ", 3) == 0) {
		/* Pode ser 6, 5 */
			labels[9][i] = labels[8][i] = labels[7][i] = labels[4][i] =
			labels[3][i] = labels[2][i] = labels[1][i] = labels[0][i] = 0;

		} else if (strncmp(s + LINE_SIZ + 3*i, "  |", 3) == 0) {
		/* Pode ser 7, 1 */
			labels[9][i] = labels[8][i] = labels[6][i] = labels[5][i] =
			labels[4][i] = labels[3][i] = labels[2][i] = labels[0][i] = 0;
		}
	}
}

void checa_terceira_linha(const char* s, char labels[10][9]) {
	/* usa strncmp() para verificar padrão em última linha da string
	 * possíveis: "|_|", "  |", "|_ ", " _|"
	 */
	int i;

	for (i=0; 3*i < LINE_SIZ - 1; ++i) {
		if (strncmp(s + 2*LINE_SIZ + 3*i, "|_|", 3) == 0) {
		/* Pode ser 8, 6, 0 */
			labels[9][i] = labels[7][i] = labels[5][i] = labels[4][i] =
			labels[3][i] = labels[2][i] = labels[1][i] = 0;

		} else if (strncmp(s + 2*LINE_SIZ + 3*i, "  |", 3) == 0) {
		/* Pode ser 7, 4, 1 */
			labels[9][i] = labels[8][i] = labels[6][i] = labels[5][i] =
			labels[3][i] = labels[2][i] = labels[0][i] = 0;

		} else if (strncmp(s + 2*LINE_SIZ + 3*i, "|_ ", 3) == 0) {
		/* Pode ser 2 */
			labels[9][i] = labels[8][i] = labels[7][i] = labels[6][i] =
			labels[5][i] = labels[4][i] = labels[3][i] = labels[1][i] =
			labels[0][i] = 0;

		} else if (strncmp(s + 2*LINE_SIZ + 3*i, " _|", 3) == 0) {
		/* Pode ser 9, 5, 3 */
			labels[8][i] = labels[7][i] = labels[6][i] = labels[4][i] =
			labels[2][i] = labels[1][i] = labels[0][i] = 0;
		}
	}
}

/* Transforma string de entrada em um inteiro */
int ocr(const char* s) {
	char labels[10][9];
	int i, j;
	int resultado=0;

	/* set todas possibilidades como true */
	set_labels(labels);

	/* filtra possíveis números */
	checa_primeira_linha(s, labels);
	checa_segunda_linha(s, labels);
	checa_terceira_linha(s, labels);

	/* monta inteiro a partir das labels achadas */
	for (j=0; j < 9; ++j) {
		for (i=0; i < 10; ++i) {
			if (labels[i][j] == 1) {
				resultado += i;
				if (j < 8)
					resultado *= 10;
				break;
			}
		}
	}

	return resultado;
}

/* Testes */
static char* test_ocr() {
	char* s = display_testes[0]; 

	MU_ASSERT("Falha: teste 000000000", ocr(s) == 0);

	s = display_testes[1];
	MU_ASSERT("Falha: teste 000000001", ocr(s) == 1);

	s = display_testes[2];
	MU_ASSERT("Falha: teste 000000004", ocr(s) == 4);

	s = display_testes[3];
	MU_ASSERT("Falha: teste 000000009", ocr(s) == 9);

	s = display_testes[4];
	MU_ASSERT("Falha: teste 000000008", ocr(s) == 8);

	s = display_testes[5];
	MU_ASSERT("Falha: teste 000000070", ocr(s) == 70);

	s = display_testes[6];
	MU_ASSERT("Falha: teste 000000013", ocr(s) == 13);

	s = display_testes[7];
	MU_ASSERT("Falha: teste 000000077", ocr(s) == 77);

	s = display_testes[8];
	MU_ASSERT("Falha: teste 123456789", ocr(s) == 123456789);

	s = display_testes[9];
	MU_ASSERT("Falha: teste 987654321", ocr(s) == 987654321);

	return 0;
}

/* Roda todos testes listados */
static char* all_tests() {
	MU_RUN_TEST(test_ocr);
	return 0;
}


/*
 *Main: somente executa testes e imprime mensagens de erro
 */
int main() {
	char* result = all_tests();

	if (result != 0) {
		puts(result);
	} else {
		puts("Todos testes passaram.");
	}

	printf("Testes executados: %d\n", tests_run);

	return result != 0;
}
